[LeetCode]Longest Valid Parentheses(!!!)

来源:互联网 发布:飞腾排版软件课件 编辑:程序博客网 时间:2024/05/16 07:10

Given a string containing just the characters ‘(’ and ‘)’, find the
length of the longest valid (well-formed) parentheses substring.

For “(()”, the longest valid parentheses substring is “()”, which has
length = 2.

Another example is “)()())”, where the longest valid parentheses
substring is “()()”, which has length = 4.

先介绍一种简单易懂的方法,用一个bool数组来标记已经匹配过的字符,在压栈和出栈的过程中是对字符的下标进行操作的。这样再遍历一次bool数组,找出最长连续的标记即为结果。O(n)

class Solution {public:    int longestValidParentheses(string s) {        bool *a = new bool[s.length()];        memset(a, false, s.length());        stack<int> st;        for (int i = 0; i < s.length(); ++i) {            if (s[i] == '(') {                st.push(i);            } else if (s[i] == ')' && !st.empty()) {                a[i] = true;                a[st.top()] = true;                st.pop();            }        }        int max_len = 0, cur_len = 0;        for (int i = 0; i < s.length(); ++i) {            if (a[i]) ++cur_len;            else cur_len = 0;            max_len = max(max_len, cur_len);        }        return max_len;    }};

DP算法(NB啊。。。)
解法:
这道题可以用一维动态规划逆向求解。假设输入括号表达式为String s,维护一个长度为s.length的一维数组dp[],数组元素初始化为0。 dp[i]表示从s[i]到s[s.length - 1]包含s[i]的最长的有效匹配括号子串长度。则存在如下关系:

  • dp[s.length - 1] = 0;
  • i从n - 2 -> 0逆向求dp[],并记录其最大值。若s[i] == ‘(‘,则在s中从i开始到s.length -
    1计算dp[i]的值。这个计算分为两步,通过dp[i + 1]进行的(注意dp[i + 1]已经在上一步求解):
    • 在s中寻找从i + 1开始的有效括号匹配子串长度,即dp[i + 1],跳过这段有效的括号子串,查看下一个字符,其下标为j = i + 1 + dp[i + 1]。若j没有越界,并且s[j] == ‘)’,则s[i … j]为有效括号匹配,dp[i] =dp[i + 1] + 2。
    • 在求得了s[i … j]的有效匹配长度之后,若j + 1没有越界,则dp[i]的值还要加上从j + 1开始的最长有效匹配,即dp[j + 1]。
#include <stdio.h>#include <string.h>#define N 65536int longestValidParentheses(const char *s){    int i,j,n;    int dp[N];    int max=0;    n=strlen(s);    for(i=0;i<N;i++)        dp[i]=0;    for(i=n-2;i>=0;i--)    {        if(s[i]=='(')        {            j=i+1+dp[i+1];            if(j<n && s[j]==')')            {                dp[i]=dp[i+1]+2;                if(j+1<n)                    dp[i]+=dp[j+1];            }        }        if(max<=dp[i])            max=dp[i];    }    return max;}int main(){           const char *s="))()()";    printf("%d\n",longestValidParentheses(s));    return 0;} 

当然还有一种正向DP

My solution uses DP. The main idea is as follows: I construct a array
longest[], for any longest[i], it stores the longest length of valid
parentheses which is end at i. And the DP idea is : If s[i] is ‘(‘,
set longest[i] to 0,because any string end with ‘(’ cannot be a valid
one. Else if s[i] is ‘)’
If s[i-1] is ‘(‘, longest[i] = longest[i-2] + 2
Else if s[i-1] is ‘)’ and s[i-longest[i-1]-1] == ‘(‘, longest[i] = longest[i-1] + 2 + longest[i-longest[i-1]-2] For example, input “()(())”, at i = 5, longest array is [0,2,0,0,2,0], longest[5] =
longest[4] + 2 + longest[1] = 6.

 int longestValidParentheses(string s) {            if(s.length() <= 1) return 0;            int curMax = 0;            vector<int> longest(s.size(),0);            for(int i=1; i < s.length(); i++){                if(s[i] == ')'){                    if(s[i-1] == '('){                        longest[i] = (i-2) >= 0 ? (longest[i-2] + 2) : 2;                        curMax = max(longest[i],curMax);                    }                    else{ // if s[i-1] == ')', combine the previous length.                        if(i-longest[i-1]-1 >= 0 && s[i-longest[i-1]-1] == '('){                            longest[i] = longest[i-1] + 2 + ((i-longest[i-1]-2 >= 0)?longest[i-longest[i-1]-2]:0);                            curMax = max(longest[i],curMax);                        }                    }                }                //else if s[i] == '(', skip it, because longest[i] must be 0            }            return curMax;        }
0 0